<template>
  <div class="card-grid">
    <div v-for="(card, index) in cards" :key="index" class="cdx-docs-card-group-with-thumbnails__card"
         @mouseover="hoveredCardIndex = index" @mouseleave="hoveredCardIndex = null">
      <cdx-card>
        <template #title>
          {{ card.title }}
        </template>
        <template #description>
          {{ card.description }}
        </template>
      </cdx-card>
      <div class="tooltip" v-show="hoveredCardIndex === index">
        <span class="text">
          {{ card.tooltip }}
        </span>
      </div>
    </div>
  </div>
</template>




<script setup lang="ts">
import { computed, onMounted, watch, ref } from 'vue';
import { CdxCard } from '@wikimedia/codex';

const props = defineProps<{
  cards: any;
}>();

const hoveredCardIndex: any = ref(null);

// We divide the number of cards by 5 to determine the number of columns so that the cards are evenly distributed.
const numberOfColumns = computed(() => Math.ceil(props.cards.length / 5).toString());
computed(() => {
  setStyle();
});

onMounted(() => {
  // We set the number of columns as a CSS variable so that the grid can be responsive.
  setStyle();
});

watch(
  () => numberOfColumns.value,
  () => {
    setStyle();
  }
);


function setStyle() {
  document.documentElement.style.setProperty('--card-grid-track', numberOfColumns.value);
}


</script>


<style scoped lang="less">
@import (reference) '@wikimedia/codex-design-tokens/theme-wikimedia-ui.less';

.cdx-docs-card-group-with-thumbnails {
  p {
    margin-top: 0;
    font-weight: @font-weight-bold;
  }

  // The application implementing Cards must handle Card group layout styles.
  &__card {
    margin-bottom: @spacing-100;

    &:last-child {
      margin-bottom: 0;
    }
  }
}
</style>

<style lang="scss">
:root {
  --card-grid-track: 1;
}

@import '@/scss/_mixins.scss';

.card-grid {

  @include card-grid;

}

.tooltip {
  color: brown;
  position: relative;
  top: 10%;
  transform: translateX(2%);
  padding: 10px;
  border-radius: 5px;
  z-index: 1;
  transition: opacity 0.3s;
  max-height: 200px;
  overflow-y: auto;
}

</style>